#include <iostream>
#include <chrono>
#include <functional>
#include "concurrentQueue.h"
using namespace std;
// Example of a computation
void processTask(int taskId) {
   cout << "Processing task " << taskId << " in thread " << this_thread::get_id() << endl;
   this_thread::sleep_for (chrono::seconds(1)); // task processing
}
int main() {
   const int numTasks = 10;
   const int numThreads = 3 ;//std::thread::hardware_concurrency();
   cout << "Executing " << numTasks << " tasks in a thread pool of: " << numThreads << " threads" << endl;
   ThreadPool threadPool(numThreads);
   for (int i = 0; i < numTasks; ++i) {
      threadPool.enqueue(processTask, i);
   }
   return 0;
}
